#ifndef CONF_H
#define CONF_H

/* Forwarding to the given hosts for the given port numbers */
struct cluster_t
{
	int *ports;
	char **nodes;
	int portsnum;
	int nodesnum;
	int destport;
};

/* Quality of Service */
struct qos_t
{
	int port1;
	int port2;
	long timeout;
};

/* A complete MoreBalance configuration */
struct conf_t
{
	char valid;
	struct cluster_t **cluster;
	struct qos_t **qos;
	int qosnum;
	int clusternum;
	int verbose;
};

/* Type definitions */
typedef struct conf_t conf;
typedef struct cluster_t cluster;
typedef struct qos_t qos;

/* Read in a configuration */
conf conf_read(const char *filename);

/* Optimize a configuration */
void conf_optimize(conf *c);

/* Dump a configuration to stdout */
void conf_dump(conf c);

#endif

